'''
Intent of this file is ...

https://msdn.microsoft.com/en-us/library/windows/desktop/bb775771(v=vs.85).aspx
Using SHFileOperation as the MSDN advise to use it for multithread

IFileOperation can only be applied in a single-threaded apartment (STA) situation. It cannot be used for a multithreaded apartment (MTA) situation. For MTA, you still must use SHFileOperation.
'''
from nxdrive.client.local_client import LocalClient
from win32com.shell import shell, shellcon


class WindowsClient(LocalClient):
    def __init__(self, base_folder, digest_func='md5', ignored_prefixes=None,
                    ignored_suffixes=None, check_suspended=None, case_sensitive=None, disable_duplication=False):
        super(WindowsClient, self).__init__(base_folder, digest_func, ignored_prefixes, ignored_suffixes,
                                            check_suspended, case_sensitive, disable_duplication)

    def delete_final(self, ref):
        super(WindowsClient, self).delete_final(ref)

    def move(self, ref, new_parent_ref, name=None):
        return super(WindowsClient, self).move(ref, new_parent_ref, name)

    def duplicate_file(self, ref):
        return super(WindowsClient, self).duplicate_file(ref)

    def rename(self, ref, to_name):
        return super(WindowsClient, self).rename(ref, to_name)

    def delete(self, ref):
        super(WindowsClient, self).delete(ref)